# Day 01

## Introduction to chatbot
- [Developing Korean Chatbot 101](https://www.slideshare.net/JaeminCho6/developing-korean-chatbot-101-71013451)

## Dataset

### Korean
- [세종코퍼스- 국립국어원 언어정보나눔터](https://ithub.korean.go.kr/user/main.do)
- [위키피디아](https://dumps.wikimedia.org/kowiki/) [Extractor](https://github.com/j-min/WikiExtractor_To_the_one_text)
- [나무위키](https://namu.wiki/w/%EB%82%98%EB%AC%B4%EC%9C%84%ED%82%A4:%EB%8D%B0%EC%9D%B4%ED%84%B0%EB%B2%A0%EC%9D%B4%EC%8A%A4%20%EB%8D%A4%ED%94%84) [Extractor](https://github.com/j-min/Easy-Namuwiki-Extractor)
- [네이버 영화 리뷰](https://github.com/e9t/nsmc)

### English
#### Language modelng
- [PTB](http://www.nltk.org/nltk_data/)

#### Translation
- [WMT 2014](http://www.statmt.org/wmt14/translation-task.html#download)

#### Dialogue
- [Ubuntu Dialogue Corpus](https://github.com/rkadlec/ubuntu-ranking-dataset-creator) (requires Python2/unicodecsv/nltk)

#### QA
- [bAbI](https://research.fb.com/downloads/babi/)
- [SQUAD](https://rajpurkar.github.io/SQuAD-explorer/)
- [WikiQA](https://www.microsoft.com/en-us/download/details.aspx?id=52419)
- [NewsQA](https://datasets.maluuba.com/NewsQA)

#### Dialogue Environment
- [CommAI](https://github.com/facebookresearch/CommAI-env)
- [ParlAI](https://github.com/facebookresearch/ParlAI/)


## NLP/ML Toolkits
#### English
- [NLTK](www.nltk.org/index.html)
- [spaCy](https://spacy.io/)

#### Korean
- [konlpy](http://konlpy.org/)
- [hangul-toolkit](https://github.com/bluedisk/hangul-toolkit)

## Training Word Vector
- [Gensim](https://radimrehurek.com/gensim/)
- [FastText.py](https://github.com/salestock/fastText.py)

## Text Classification with TF-IDF
- [Scikit-Learn](scikit-learn.org/stable/modules/generated/sklearn.feature_extraction.text.TfidfVectorizer.html)

## Didn't covered, but recommended
- [python-crfsuite](https://github.com/scrapinghub/python-crfsuite)
	- [NER(개체명인식)](https://github.com/scrapinghub/python-crfsuite/blob/master/examples/CoNLL%202002.ipynb)
	- [Spacing(띄어쓰기)](http://blog.theeluwin.kr/post/147587579528/python-crfsuite%EB%A5%BC-%EC%82%AC%EC%9A%A9%ED%95%B4%EC%84%9C-%ED%95%9C%EA%B5%AD%EC%96%B4-%EC%9E%90%EB%8F%99-%EB%9D%84%EC%96%B4%EC%93%B0%EA%B8%B0%EB%A5%BC-%ED%95%99%EC%8A%B5%ED%95%B4%EB%B3%B4%EC%9E%90)
- [국립국어원 국어정보처리시스템 경진대회](https://ithub.korean.go.kr/user/contest/contestIntroLastView.do)
